# coding: utf-8

"""
    Determined API (Beta)

    Determined helps deep learning teams train models more quickly, easily share GPU resources, and effectively collaborate. Determined allows deep learning engineers to focus on building and training models at scale, without needing to worry about DevOps or writing custom code for common tasks like fault tolerance or experiment tracking.  You can think of Determined as a platform that bridges the gap between tools like TensorFlow and PyTorch --- which work great for a single researcher with a single GPU --- to the challenges that arise when doing deep learning at scale, as teams, clusters, and data sets all increase in size.  # noqa: E501

    OpenAPI spec version: 0.1
    Contact: community@determined.ai
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from determined._swagger.client.api_client import ApiClient


class CheckpointsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def determined_get_checkpoint(self, checkpoint_uuid, **kwargs):  # noqa: E501
        """Get the requested checkpoint.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.determined_get_checkpoint(checkpoint_uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str checkpoint_uuid: The uuid for the requested checkpoint. (required)
        :return: V1GetCheckpointResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.determined_get_checkpoint_with_http_info(checkpoint_uuid, **kwargs)  # noqa: E501
        else:
            (data) = self.determined_get_checkpoint_with_http_info(checkpoint_uuid, **kwargs)  # noqa: E501
            return data

    def determined_get_checkpoint_with_http_info(self, checkpoint_uuid, **kwargs):  # noqa: E501
        """Get the requested checkpoint.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.determined_get_checkpoint_with_http_info(checkpoint_uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str checkpoint_uuid: The uuid for the requested checkpoint. (required)
        :return: V1GetCheckpointResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['checkpoint_uuid']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method determined_get_checkpoint" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'checkpoint_uuid' is set
        if ('checkpoint_uuid' not in params or
                params['checkpoint_uuid'] is None):
            raise ValueError("Missing the required parameter `checkpoint_uuid` when calling `determined_get_checkpoint`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'checkpoint_uuid' in params:
            path_params['checkpointUuid'] = params['checkpoint_uuid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BearerToken']  # noqa: E501

        return self.api_client.call_api(
            '/api/v1/checkpoints/{checkpointUuid}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='V1GetCheckpointResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def determined_post_checkpoint_metadata(self, checkpoint_uuid, body, **kwargs):  # noqa: E501
        """Update checkpoint metadata.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.determined_post_checkpoint_metadata(checkpoint_uuid, body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str checkpoint_uuid: UUID of the checkpoint. (required)
        :param V1PostCheckpointMetadataRequest body: (required)
        :return: V1PostCheckpointMetadataResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.determined_post_checkpoint_metadata_with_http_info(checkpoint_uuid, body, **kwargs)  # noqa: E501
        else:
            (data) = self.determined_post_checkpoint_metadata_with_http_info(checkpoint_uuid, body, **kwargs)  # noqa: E501
            return data

    def determined_post_checkpoint_metadata_with_http_info(self, checkpoint_uuid, body, **kwargs):  # noqa: E501
        """Update checkpoint metadata.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.determined_post_checkpoint_metadata_with_http_info(checkpoint_uuid, body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str checkpoint_uuid: UUID of the checkpoint. (required)
        :param V1PostCheckpointMetadataRequest body: (required)
        :return: V1PostCheckpointMetadataResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['checkpoint_uuid', 'body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method determined_post_checkpoint_metadata" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'checkpoint_uuid' is set
        if ('checkpoint_uuid' not in params or
                params['checkpoint_uuid'] is None):
            raise ValueError("Missing the required parameter `checkpoint_uuid` when calling `determined_post_checkpoint_metadata`")  # noqa: E501
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `determined_post_checkpoint_metadata`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'checkpoint_uuid' in params:
            path_params['checkpoint.uuid'] = params['checkpoint_uuid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BearerToken']  # noqa: E501

        return self.api_client.call_api(
            '/api/v1/checkpoints/{checkpoint.uuid}/metadata', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='V1PostCheckpointMetadataResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
