# coding: utf-8

"""
    Determined API (Beta)

    Determined helps deep learning teams train models more quickly, easily share GPU resources, and effectively collaborate. Determined allows deep learning engineers to focus on building and training models at scale, without needing to worry about DevOps or writing custom code for common tasks like fault tolerance or experiment tracking.  You can think of Determined as a platform that bridges the gap between tools like TensorFlow and PyTorch --- which work great for a single researcher with a single GPU --- to the challenges that arise when doing deep learning at scale, as teams, clusters, and data sets all increase in size.  # noqa: E501

    OpenAPI spec version: 0.1
    Contact: community@determined.ai
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class GetTrialResponseWorkloadContainer(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'training': 'V1MetricsWorkload',
        'validation': 'V1MetricsWorkload',
        'checkpoint': 'V1CheckpointWorkload'
    }

    attribute_map = {
        'training': 'training',
        'validation': 'validation',
        'checkpoint': 'checkpoint'
    }

    def __init__(self, training=None, validation=None, checkpoint=None):  # noqa: E501
        """GetTrialResponseWorkloadContainer - a model defined in Swagger"""  # noqa: E501

        self._training = None
        self._validation = None
        self._checkpoint = None
        self.discriminator = None

        if training is not None:
            self.training = training
        if validation is not None:
            self.validation = validation
        if checkpoint is not None:
            self.checkpoint = checkpoint

    @property
    def training(self):
        """Gets the training of this GetTrialResponseWorkloadContainer.  # noqa: E501

        Training workload.  # noqa: E501

        :return: The training of this GetTrialResponseWorkloadContainer.  # noqa: E501
        :rtype: V1MetricsWorkload
        """
        return self._training

    @training.setter
    def training(self, training):
        """Sets the training of this GetTrialResponseWorkloadContainer.

        Training workload.  # noqa: E501

        :param training: The training of this GetTrialResponseWorkloadContainer.  # noqa: E501
        :type: V1MetricsWorkload
        """

        self._training = training

    @property
    def validation(self):
        """Gets the validation of this GetTrialResponseWorkloadContainer.  # noqa: E501

        Validation workload.  # noqa: E501

        :return: The validation of this GetTrialResponseWorkloadContainer.  # noqa: E501
        :rtype: V1MetricsWorkload
        """
        return self._validation

    @validation.setter
    def validation(self, validation):
        """Sets the validation of this GetTrialResponseWorkloadContainer.

        Validation workload.  # noqa: E501

        :param validation: The validation of this GetTrialResponseWorkloadContainer.  # noqa: E501
        :type: V1MetricsWorkload
        """

        self._validation = validation

    @property
    def checkpoint(self):
        """Gets the checkpoint of this GetTrialResponseWorkloadContainer.  # noqa: E501

        Checkpoint workload.  # noqa: E501

        :return: The checkpoint of this GetTrialResponseWorkloadContainer.  # noqa: E501
        :rtype: V1CheckpointWorkload
        """
        return self._checkpoint

    @checkpoint.setter
    def checkpoint(self, checkpoint):
        """Sets the checkpoint of this GetTrialResponseWorkloadContainer.

        Checkpoint workload.  # noqa: E501

        :param checkpoint: The checkpoint of this GetTrialResponseWorkloadContainer.  # noqa: E501
        :type: V1CheckpointWorkload
        """

        self._checkpoint = checkpoint

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetTrialResponseWorkloadContainer, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetTrialResponseWorkloadContainer):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
