# coding: utf-8

"""
    Determined API (Beta)

    Determined helps deep learning teams train models more quickly, easily share GPU resources, and effectively collaborate. Determined allows deep learning engineers to focus on building and training models at scale, without needing to worry about DevOps or writing custom code for common tasks like fault tolerance or experiment tracking.  You can think of Determined as a platform that bridges the gap between tools like TensorFlow and PyTorch --- which work great for a single researcher with a single GPU --- to the challenges that arise when doing deep learning at scale, as teams, clusters, and data sets all increase in size.  # noqa: E501

    OpenAPI spec version: 0.1
    Contact: community@determined.ai
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class V1ExperimentSimulation(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'config': 'object',
        'seed': 'int',
        'trials': 'list[V1TrialSimulation]'
    }

    attribute_map = {
        'config': 'config',
        'seed': 'seed',
        'trials': 'trials'
    }

    def __init__(self, config=None, seed=None, trials=None):  # noqa: E501
        """V1ExperimentSimulation - a model defined in Swagger"""  # noqa: E501

        self._config = None
        self._seed = None
        self._trials = None
        self.discriminator = None

        if config is not None:
            self.config = config
        if seed is not None:
            self.seed = seed
        if trials is not None:
            self.trials = trials

    @property
    def config(self):
        """Gets the config of this V1ExperimentSimulation.  # noqa: E501

        The simulated experiment config.  # noqa: E501

        :return: The config of this V1ExperimentSimulation.  # noqa: E501
        :rtype: object
        """
        return self._config

    @config.setter
    def config(self, config):
        """Sets the config of this V1ExperimentSimulation.

        The simulated experiment config.  # noqa: E501

        :param config: The config of this V1ExperimentSimulation.  # noqa: E501
        :type: object
        """

        self._config = config

    @property
    def seed(self):
        """Gets the seed of this V1ExperimentSimulation.  # noqa: E501

        The searcher simulation seed.  # noqa: E501

        :return: The seed of this V1ExperimentSimulation.  # noqa: E501
        :rtype: int
        """
        return self._seed

    @seed.setter
    def seed(self, seed):
        """Sets the seed of this V1ExperimentSimulation.

        The searcher simulation seed.  # noqa: E501

        :param seed: The seed of this V1ExperimentSimulation.  # noqa: E501
        :type: int
        """

        self._seed = seed

    @property
    def trials(self):
        """Gets the trials of this V1ExperimentSimulation.  # noqa: E501

        The list of trials in the simulation.  # noqa: E501

        :return: The trials of this V1ExperimentSimulation.  # noqa: E501
        :rtype: list[V1TrialSimulation]
        """
        return self._trials

    @trials.setter
    def trials(self, trials):
        """Sets the trials of this V1ExperimentSimulation.

        The list of trials in the simulation.  # noqa: E501

        :param trials: The trials of this V1ExperimentSimulation.  # noqa: E501
        :type: list[V1TrialSimulation]
        """

        self._trials = trials

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(V1ExperimentSimulation, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, V1ExperimentSimulation):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
