# coding: utf-8

"""
    Determined API (Beta)

    Determined helps deep learning teams train models more quickly, easily share GPU resources, and effectively collaborate. Determined allows deep learning engineers to focus on building and training models at scale, without needing to worry about DevOps or writing custom code for common tasks like fault tolerance or experiment tracking.  You can think of Determined as a platform that bridges the gap between tools like TensorFlow and PyTorch --- which work great for a single researcher with a single GPU --- to the challenges that arise when doing deep learning at scale, as teams, clusters, and data sets all increase in size.  # noqa: E501

    OpenAPI spec version: 0.1
    Contact: community@determined.ai
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class V1LoginRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'username': 'str',
        'password': 'str',
        'is_hashed': 'bool'
    }

    attribute_map = {
        'username': 'username',
        'password': 'password',
        'is_hashed': 'isHashed'
    }

    def __init__(self, username=None, password=None, is_hashed=None):  # noqa: E501
        """V1LoginRequest - a model defined in Swagger"""  # noqa: E501

        self._username = None
        self._password = None
        self._is_hashed = None
        self.discriminator = None

        self.username = username
        self.password = password
        if is_hashed is not None:
            self.is_hashed = is_hashed

    @property
    def username(self):
        """Gets the username of this V1LoginRequest.  # noqa: E501

        The username of the user.  # noqa: E501

        :return: The username of this V1LoginRequest.  # noqa: E501
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username):
        """Sets the username of this V1LoginRequest.

        The username of the user.  # noqa: E501

        :param username: The username of this V1LoginRequest.  # noqa: E501
        :type: str
        """
        if username is None:
            raise ValueError("Invalid value for `username`, must not be `None`")  # noqa: E501

        self._username = username

    @property
    def password(self):
        """Gets the password of this V1LoginRequest.  # noqa: E501

        The password of the user.  # noqa: E501

        :return: The password of this V1LoginRequest.  # noqa: E501
        :rtype: str
        """
        return self._password

    @password.setter
    def password(self, password):
        """Sets the password of this V1LoginRequest.

        The password of the user.  # noqa: E501

        :param password: The password of this V1LoginRequest.  # noqa: E501
        :type: str
        """
        if password is None:
            raise ValueError("Invalid value for `password`, must not be `None`")  # noqa: E501

        self._password = password

    @property
    def is_hashed(self):
        """Gets the is_hashed of this V1LoginRequest.  # noqa: E501

        Indicate whether the provided password is pre-salted & hashed or not.  # noqa: E501

        :return: The is_hashed of this V1LoginRequest.  # noqa: E501
        :rtype: bool
        """
        return self._is_hashed

    @is_hashed.setter
    def is_hashed(self, is_hashed):
        """Sets the is_hashed of this V1LoginRequest.

        Indicate whether the provided password is pre-salted & hashed or not.  # noqa: E501

        :param is_hashed: The is_hashed of this V1LoginRequest.  # noqa: E501
        :type: bool
        """

        self._is_hashed = is_hashed

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(V1LoginRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, V1LoginRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
