# coding: utf-8

"""
    Determined API (Beta)

    Determined helps deep learning teams train models more quickly, easily share GPU resources, and effectively collaborate. Determined allows deep learning engineers to focus on building and training models at scale, without needing to worry about DevOps or writing custom code for common tasks like fault tolerance or experiment tracking.  You can think of Determined as a platform that bridges the gap between tools like TensorFlow and PyTorch --- which work great for a single researcher with a single GPU --- to the challenges that arise when doing deep learning at scale, as teams, clusters, and data sets all increase in size.  # noqa: E501

    OpenAPI spec version: 0.1
    Contact: community@determined.ai
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class V1MetricNamesResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'searcher_metric': 'str',
        'training_metrics': 'list[str]',
        'validation_metrics': 'list[str]'
    }

    attribute_map = {
        'searcher_metric': 'searcherMetric',
        'training_metrics': 'trainingMetrics',
        'validation_metrics': 'validationMetrics'
    }

    def __init__(self, searcher_metric=None, training_metrics=None, validation_metrics=None):  # noqa: E501
        """V1MetricNamesResponse - a model defined in Swagger"""  # noqa: E501

        self._searcher_metric = None
        self._training_metrics = None
        self._validation_metrics = None
        self.discriminator = None

        if searcher_metric is not None:
            self.searcher_metric = searcher_metric
        if training_metrics is not None:
            self.training_metrics = training_metrics
        if validation_metrics is not None:
            self.validation_metrics = validation_metrics

    @property
    def searcher_metric(self):
        """Gets the searcher_metric of this V1MetricNamesResponse.  # noqa: E501

        The name of the searcher metric.  # noqa: E501

        :return: The searcher_metric of this V1MetricNamesResponse.  # noqa: E501
        :rtype: str
        """
        return self._searcher_metric

    @searcher_metric.setter
    def searcher_metric(self, searcher_metric):
        """Sets the searcher_metric of this V1MetricNamesResponse.

        The name of the searcher metric.  # noqa: E501

        :param searcher_metric: The searcher_metric of this V1MetricNamesResponse.  # noqa: E501
        :type: str
        """

        self._searcher_metric = searcher_metric

    @property
    def training_metrics(self):
        """Gets the training_metrics of this V1MetricNamesResponse.  # noqa: E501

        List of training metric names.  # noqa: E501

        :return: The training_metrics of this V1MetricNamesResponse.  # noqa: E501
        :rtype: list[str]
        """
        return self._training_metrics

    @training_metrics.setter
    def training_metrics(self, training_metrics):
        """Sets the training_metrics of this V1MetricNamesResponse.

        List of training metric names.  # noqa: E501

        :param training_metrics: The training_metrics of this V1MetricNamesResponse.  # noqa: E501
        :type: list[str]
        """

        self._training_metrics = training_metrics

    @property
    def validation_metrics(self):
        """Gets the validation_metrics of this V1MetricNamesResponse.  # noqa: E501

        List of validation metric names.  # noqa: E501

        :return: The validation_metrics of this V1MetricNamesResponse.  # noqa: E501
        :rtype: list[str]
        """
        return self._validation_metrics

    @validation_metrics.setter
    def validation_metrics(self, validation_metrics):
        """Sets the validation_metrics of this V1MetricNamesResponse.

        List of validation metric names.  # noqa: E501

        :param validation_metrics: The validation_metrics of this V1MetricNamesResponse.  # noqa: E501
        :type: list[str]
        """

        self._validation_metrics = validation_metrics

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(V1MetricNamesResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, V1MetricNamesResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
