# coding: utf-8

"""
    Determined API (Beta)

    Determined helps deep learning teams train models more quickly, easily share GPU resources, and effectively collaborate. Determined allows deep learning engineers to focus on building and training models at scale, without needing to worry about DevOps or writing custom code for common tasks like fault tolerance or experiment tracking.  You can think of Determined as a platform that bridges the gap between tools like TensorFlow and PyTorch --- which work great for a single researcher with a single GPU --- to the challenges that arise when doing deep learning at scale, as teams, clusters, and data sets all increase in size.  # noqa: E501

    OpenAPI spec version: 0.1
    Contact: community@determined.ai
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class V1SearcherOperation(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'validate_after': 'V1ValidateAfterOperation'
    }

    attribute_map = {
        'validate_after': 'validateAfter'
    }

    def __init__(self, validate_after=None):  # noqa: E501
        """V1SearcherOperation - a model defined in Swagger"""  # noqa: E501

        self._validate_after = None
        self.discriminator = None

        if validate_after is not None:
            self.validate_after = validate_after

    @property
    def validate_after(self):
        """Gets the validate_after of this V1SearcherOperation.  # noqa: E501

        ValidateAfter is issued to tell a trial to train some then validate.  # noqa: E501

        :return: The validate_after of this V1SearcherOperation.  # noqa: E501
        :rtype: V1ValidateAfterOperation
        """
        return self._validate_after

    @validate_after.setter
    def validate_after(self, validate_after):
        """Sets the validate_after of this V1SearcherOperation.

        ValidateAfter is issued to tell a trial to train some then validate.  # noqa: E501

        :param validate_after: The validate_after of this V1SearcherOperation.  # noqa: E501
        :type: V1ValidateAfterOperation
        """

        self._validate_after = validate_after

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(V1SearcherOperation, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, V1SearcherOperation):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
