# coding: utf-8

"""
    Determined API (Beta)

    Determined helps deep learning teams train models more quickly, easily share GPU resources, and effectively collaborate. Determined allows deep learning engineers to focus on building and training models at scale, without needing to worry about DevOps or writing custom code for common tasks like fault tolerance or experiment tracking.  You can think of Determined as a platform that bridges the gap between tools like TensorFlow and PyTorch --- which work great for a single researcher with a single GPU --- to the challenges that arise when doing deep learning at scale, as teams, clusters, and data sets all increase in size.  # noqa: E501

    OpenAPI spec version: 0.1
    Contact: community@determined.ai
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class V1TrialSimulation(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'operations': 'list[V1RunnableOperation]',
        'occurrences': 'int'
    }

    attribute_map = {
        'operations': 'operations',
        'occurrences': 'occurrences'
    }

    def __init__(self, operations=None, occurrences=None):  # noqa: E501
        """V1TrialSimulation - a model defined in Swagger"""  # noqa: E501

        self._operations = None
        self._occurrences = None
        self.discriminator = None

        if operations is not None:
            self.operations = operations
        if occurrences is not None:
            self.occurrences = occurrences

    @property
    def operations(self):
        """Gets the operations of this V1TrialSimulation.  # noqa: E501

        The list of operations that were run before the trial was completed.  # noqa: E501

        :return: The operations of this V1TrialSimulation.  # noqa: E501
        :rtype: list[V1RunnableOperation]
        """
        return self._operations

    @operations.setter
    def operations(self, operations):
        """Sets the operations of this V1TrialSimulation.

        The list of operations that were run before the trial was completed.  # noqa: E501

        :param operations: The operations of this V1TrialSimulation.  # noqa: E501
        :type: list[V1RunnableOperation]
        """

        self._operations = operations

    @property
    def occurrences(self):
        """Gets the occurrences of this V1TrialSimulation.  # noqa: E501

        The number of times that this trial configuration has occurred during the simulation.  # noqa: E501

        :return: The occurrences of this V1TrialSimulation.  # noqa: E501
        :rtype: int
        """
        return self._occurrences

    @occurrences.setter
    def occurrences(self, occurrences):
        """Sets the occurrences of this V1TrialSimulation.

        The number of times that this trial configuration has occurred during the simulation.  # noqa: E501

        :param occurrences: The occurrences of this V1TrialSimulation.  # noqa: E501
        :type: int
        """

        self._occurrences = occurrences

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(V1TrialSimulation, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, V1TrialSimulation):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
